package jp.sourceforge.talisman.mds.cluster;

/*
 * $Id: ClusteringParameter.java 91 2008-06-28 03:16:44Z tama3 $
 */

import jp.sourceforge.talisman.mds.Item;
import jp.sourceforge.talisman.mds.distance.DistanceCalculatorFactory;
import jp.sourceforge.talisman.mds.distance.ItemDistanceAlgorithm;
import jp.sourceforge.talisman.mds.distance.ItemDistanceCalculator;

/**
 * 
 * @author Haruaki Tamada
 * @version $Revision: 91 $ 
 */
public abstract class ClusteringParameter{
    private ItemDistanceCalculator calculator;
    private int numberOfCluster;

    public abstract boolean isValid(Item[] items);

    public final int getNumberOfCluster(){
        return numberOfCluster;
    }

    public final void setNumberOfCluster(int numberOfCluster){
        if(numberOfCluster <= 0){
            throw new IllegalArgumentException("positive value is required");
        }
        this.numberOfCluster = numberOfCluster;
    }

    public void setDistanceCalculator(ItemDistanceAlgorithm algorithm){
        setDistanceCalculator(DistanceCalculatorFactory.getInstance().getItemDistanceCalculator(algorithm));
    }

    public void setDistanceCalculator(ItemDistanceCalculator calculator){
        this.calculator = calculator;
    }

    public ItemDistanceCalculator getDistanceCalculator(){
        return calculator;
    }
}
