package jp.sourceforge.talisman.mds.cluster;

/*
 * $Id: NonHierarchicalClusteringMethod.java 90 2008-06-28 02:25:49Z tama3 $
 */

import jp.sourceforge.talisman.mds.Item;

/**
 * 
 * @author Haruaki Tamada
 * @version $Revision: 90 $ 
 */
public abstract class NonHierarchicalClusteringMethod extends AbstractClusteringMethod{
    public NonHierarchicalClusteringMethod(ClusteringParameter param){
        super(param);
    }

    @Override
    protected abstract Cluster[] doClustering(Item[] items, ClusteringParameter param);

    protected Cluster[] initClusters(Item[] items, NonHierarchicalClusteringParameter param){
        Cluster[] clusters = new Cluster[param.getNumberOfCluster()];
        // initial clustering
        for(int i = 0; i < items.length; i++){
            int index = i % clusters.length;
            if(clusters[index] == null){
                clusters[index] = new Cluster();
                clusters[index].setName("" + index);
            }
            clusters[i % clusters.length].addItem(items[i]);
        }
        return clusters;
    }
}
