package jp.sourceforge.talisman.mds.distance;

/*
 * $Id: CityBlockItemDistanceCalculator.java 90 2008-06-28 02:25:49Z tama3 $
 */

/**
 * City block (manhattan) metric calculator.
 * 
 * @author Haruaki Tamada
 * @version $Revision: 90 $ 
 */
public class CityBlockItemDistanceCalculator extends AbstractItemDistanceCalculator{

    @Override
    public ItemDistanceAlgorithm getAlgorithm(){
        return ItemDistanceAlgorithm.CITY_BLOCK_DISTANCE;
    }

    @Override
    public double calculate(double[] x, double[] y){
        validateArguments(x, y);
        double value = 0d;
        for(int i = 0; i < x.length; i++){
            if(!Double.isNaN(x[i]) && !Double.isNaN(y[i])){
                value += Math.abs(x[i] - y[i]);
            }
        }

        return value;
    }
}
