package jp.sourceforge.talisman.mds.distance;

/*
 * $Id: DominanceMetricCalculator.java 90 2008-06-28 02:25:49Z tama3 $
 */

/**
 * 
 * @author Haruaki Tamada
 * @version $Revision: 90 $ 
 */
public class DominanceMetricCalculator extends AbstractItemDistanceCalculator{
    @Override
    public ItemDistanceAlgorithm getAlgorithm(){
        return ItemDistanceAlgorithm.DOMINANCE_METRIC;
    }

    @Override
    public double calculate(double[] x, double[] y){
        validateArguments(x, y);

        double value = 0d;
        for(int i = 0; i < x.length; i++){
            if(!Double.isNaN(x[i]) && !Double.isNaN(y[i])){
                double v = Math.abs(x[i] - y[i]);
                if(value < v){
                    value = v;
                }
            }
        }

        return value;
    }
}
