package jp.sourceforge.talisman.mds.distance;

/*
 * $Id: FurthestNeighborClusterDistanceCalculator.java 104 2008-07-08 02:40:39Z tama3 $
 */

import jp.sourceforge.talisman.mds.Item;
import jp.sourceforge.talisman.mds.cluster.Cluster;

/**
 * 
 * @author Haruaki Tamada
 * @version $Revision: 104 $ 
 */
public class FurthestNeighborClusterDistanceCalculator extends AbstractClusterDistanceCalculator{
    public FurthestNeighborClusterDistanceCalculator(){
    }

    public FurthestNeighborClusterDistanceCalculator(ItemDistanceAlgorithm ida){
        super(ida);
    }

    @Override
    public ClusterDistanceAlgorithm getAlgorithm(){
        return ClusterDistanceAlgorithm.FURTHEST_NEIGHBOR_METHOD;
    }

    @Override
    public double calculate(Cluster c1, Cluster c2){
        double furthest = 0d;

        for(Item item1: c1){
            for(Item item2: c2){
                double value = getItemDistanceCalculator().calculate(item1, item2);
                if(furthest < value){
                    furthest = value;
                }
            }
        }
        return furthest;
    }

    @Override
    public double update(Cluster ci, Cluster cj, Cluster ck, double dij, double dik, double djk){
        return dik / 2d + djk / 2d + Math.abs(dik - djk) / 2d;
    }
}
