package jp.sourceforge.talisman.mds.ui.mark;

/*
 * $Id: AbstractMarkDrawer.java 90 2008-06-28 02:25:49Z tama3 $
 */

import java.awt.Graphics2D;
import java.awt.Shape;
import java.awt.Stroke;

import jp.sourceforge.talisman.mds.ui.swing.MarkDrawer;

/**
 * 
 * @author Haruaki Tamada
 * @version $Revision: 90 $ 
 */
public abstract class AbstractMarkDrawer implements MarkDrawer{
    private boolean fill;

    public AbstractMarkDrawer(){
        this(false);
    }

    public AbstractMarkDrawer(boolean fill){
        setFilled(fill);
    }

    public boolean isFilled(){
        return fill;
    }

    public void setFilled(boolean fill){
        this.fill = fill;
    }

    public abstract Shape getPlainShape(double x, double y);

    public abstract Shape getOveredShape(double x, double y);

    public Stroke getPlainStroke(){
        return null;
    }

    public Stroke getOverStroke(){
        return null;
    }

    public void draw(Graphics2D g, double x, double y){
        Stroke s = getPlainStroke();
        if(s != null){
            g.setStroke(s);
        }
        drawImpl(g, getPlainShape(x, y));
    }

    public void drawOver(Graphics2D g, double x, double y){
        Stroke s = getOverStroke();
        if(s != null){
            g.setStroke(s);
        }
        drawImpl(g, getOveredShape(x, y));
    }

    private void drawImpl(Graphics2D g, Shape s){
        if(isFilled()){
            g.fill(s);
        }
        else{
            g.draw(s);
        }
    }
}
