package jp.sourceforge.talisman.mds.ui.mark;

/*
 * $Id: MarkIcon.java 158 2008-07-15 10:45:01Z tama3 $
 */

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.swing.Icon;

import jp.sourceforge.talisman.mds.ui.swing.MarkDrawer;

/**
 * 
 * @author Haruaki Tamada
 * @version $Revision: 158 $ 
 */
public class MarkIcon implements Icon{
    private static final int DEFAULT_ICON_WIDTH = 16;
    private static final int DEFAULT_ICON_HEIGHT = 16;

    private MarkDrawer drawer;
    private int width = -1;
    private int height = -1;

    public MarkIcon(MarkDrawer drawer){
        this.drawer = drawer;
    }

    public void setIconHeight(int height){
        this.height = height;
    }

    public int getIconHeight(){
        if(height < 0){
            return DEFAULT_ICON_HEIGHT;
        }
        return height;
    }

    public void setIconWidth(int width){
        this.width = width;
    }

    public int getIconWidth(){
        if(width < 0){
            return DEFAULT_ICON_WIDTH;
        }
        return width;
    }

    public void paintIcon(Component c, Graphics g, int x, int y){
        Color initialColor = g.getColor();
        g.setColor(Color.BLACK);
        // g.translate(x, -y);
        drawer.drawOver((Graphics2D)g, getIconWidth() - x, getIconHeight() - y);
        // g.translate(-x, y);
        g.setColor(initialColor);
    }
}
