package jp.sourceforge.talisman.mds.ui.swing;

/*
 * $Id: MdsItem.java 158 2008-07-15 10:45:01Z tama3 $
 */

import java.awt.Graphics2D;

import jp.sourceforge.talisman.mds.Item;

/**
 * 
 * @author Haruaki Tamada
 * @version $Revision: 158 $ 
 */
class MdsItem extends Item{
    private MarkDrawer drawer;
    private boolean selected = false;
    private Item original;

    public MdsItem(Item item){
        super(item);
        this.original = item;
    }

    public Item getOriginal(){
        return original;
    }

    public void setDrawer(MarkDrawer drawer){
        this.drawer = drawer;
    }

    public void setSelected(boolean selected){
        this.selected = selected;
    }

    @Override
    public String getName(){
        return original.getName();
    }

    public boolean isSelected(){
        return selected;
    }

    public void paint(Graphics2D g){
        paint(g, 0d, 0d);
    }

    public void paint(Graphics2D g, double offsetX, double offsetY){
        if(isSelected()){
            drawer.drawOver(g, offsetX + get(0).doubleValue(), offsetY + get(1).doubleValue());
        }
        else{
            drawer.draw(g, offsetX + get(0).doubleValue(), offsetY + get(1).doubleValue());
        }
    }
}
