package jp.sourceforge.talisman.mds.ui.swing.actions;

/*
 * $Id: ClearAction.java 158 2008-07-15 10:45:01Z tama3 $
 */

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Icon;

import jp.sourceforge.talisman.mds.ui.swing.MdsPane;

/**
 * 
 * @author Haruaki Tamada
 * @version $Revision: 158 $ 
 */
public class ClearAction extends AbstractAction{
    private static final long serialVersionUID = -7707119498963213633L;

    private MdsPane mds;

    public ClearAction(MdsPane mds){
        super(mds.getMessages().get("clear.label"));
        this.mds = mds;
        if(mds.getMessages().hasValue("clear.tooltip")){
            putValue(SHORT_DESCRIPTION, mds.getMessages().get("clear.tooltip"));
        }
        if(mds.getMessages().hasValue("clear.icon")){
            Icon icon = mds.getMessages().getIcon("clear.icon");
            if(icon != null){
                putValue(SMALL_ICON, icon);
            }
        }
    }

    public void actionPerformed(ActionEvent e){
        mds.clearTransform();
    }
}
