package jp.sourceforge.talisman.mds.ui.swing.actions;

/*
 * $Id: ExtensionFileFilter.java 90 2008-06-28 02:25:49Z tama3 $
 */

import java.io.File;

import javax.swing.filechooser.FileFilter;

/**
 * 
 * @author Haruaki Tamada
 * @version $Revision: 90 $ 
 */
class ExtensionFileFilter extends FileFilter{
    private String extension;
    private String description;

    public ExtensionFileFilter(String extension){
        this(extension, extension);
    }

    public ExtensionFileFilter(String extension, String description){
        this.extension = extension;
        this.description = description;
    }

    public String getExtension(){
        return extension;
    }

    @Override
    public boolean accept(File f){
        return f.isDirectory() || f.getName().endsWith(getExtension());
    }

    @Override
    public String getDescription(){
        return description;
    }
}
