package jp.sourceforge.talisman.mds.ui.swing.actions;

/*
 * $Id: ShowRelationDataAction.java 158 2008-07-15 10:45:01Z tama3 $
 */

import java.awt.Component;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Icon;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

import jp.sourceforge.talisman.mds.Table;
import jp.sourceforge.talisman.mds.ui.swing.MdsPane;

/**
 * 
 * @author Haruaki Tamada
 * @version $Revision: 158 $ 
 */
public class ShowRelationDataAction extends AbstractAction{
    private static final long serialVersionUID = 770420519158203136L;

    private MdsPane mds;
    private Component parent;

    /**
     * this(mds, mds);
     */
    public ShowRelationDataAction(MdsPane mds){
        this(mds, mds);
    }

    public ShowRelationDataAction(Component parent, MdsPane mds){
        super(mds.getMessages().get("show.relation.label"));
        this.parent = parent;
        this.mds = mds;

        if(mds.getMessages().hasValue("show.relation.tooltip")){
            putValue(SHORT_DESCRIPTION, mds.getMessages().get("show.relation.tooltip"));
        }
        if(mds.getMessages().hasValue("show.relation.icon")){
            Icon icon = mds.getMessages().getIcon("show.relation.icon");
            putValue(SMALL_ICON, icon);
        }
    }

    public void actionPerformed(ActionEvent e){
        JOptionPane.showMessageDialog(
            parent, createPane(), mds.getMessages().get("show.relation.title"),
            JOptionPane.INFORMATION_MESSAGE
        );
    }

    @SuppressWarnings("unchecked")
    private Component createPane(){
        DefaultTableModel model = new UneditableDefaultTableModel();
        TableSorter sorter = new TableSorter(model);
        JTable table = new JTable(sorter);
        sorter.setTableHeader(table.getTableHeader());

        Table sheet = mds.getTable();
        Object[] names = sheet.getKeys();
        model.addColumn("");
        for(int i = 0; i < names.length; i++){
            model.addColumn(names[i]);
        }
        for(int i = 0; i < names.length; i++){
            String[] values = new String[i + 2];
            values[0] = String.valueOf(names[i]);
            for(int j = 0; j <= i; j++){
                values[j + 1] = String.valueOf(sheet.getValue(names[i], names[j]));
            }
            model.addRow(values);
        }

        return new JScrollPane(table, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
    }
}
