package jp.sourceforge.talisman.mds.cluster;

/*
 * $Id: DummyClusteringParameterTest.java 158 2008-07-15 10:45:01Z tama3 $
 */

import jp.sourceforge.talisman.mds.Item;
import jp.sourceforge.talisman.mds.distance.CityBlockItemDistanceCalculator;
import jp.sourceforge.talisman.mds.distance.DistanceCalculatorFactory;
import jp.sourceforge.talisman.mds.distance.DominanceMetricCalculator;
import jp.sourceforge.talisman.mds.distance.ItemDistanceAlgorithm;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

/**
 * 
 * @author Haruaki Tamada
 * @version $Revision: 158 $ 
 */
public class DummyClusteringParameterTest{
    private ClusteringParameter param;

    @Before
    public void initialize(){
        param = new DummyClusteringParameter();
    }

    @Test
    public void testOK(){
        Assert.assertTrue(param.isValid(new Item[3]));
        Assert.assertTrue(param.isValid(null));
    }

    @Test
    public void testCalculator(){
        param.setDistanceCalculator(ItemDistanceAlgorithm.CITY_BLOCK_DISTANCE);

        Assert.assertTrue(param.getDistanceCalculator() instanceof CityBlockItemDistanceCalculator);

        param.setDistanceCalculator(DistanceCalculatorFactory.getInstance().getItemDistanceCalculator(ItemDistanceAlgorithm.DOMINANCE_METRIC));
        Assert.assertTrue(param.getDistanceCalculator() instanceof DominanceMetricCalculator);
    }

    @Test(expected=IllegalArgumentException.class)
    public void testSetNegativeValueToNumberOfCluster(){
        param.setNumberOfCluster(-1);
    }

    @Test(expected=IllegalArgumentException.class)
    public void testSetZeroToNumberOfCluster(){
        param.setNumberOfCluster(0);
    }
}
