package jp.sourceforge.talisman.mds.distance;

/*
 * $Id: DistanceCalculatorFactoryTest.java 158 2008-07-15 10:45:01Z tama3 $
 */

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

/**
 * 
 * @author Haruaki Tamada
 * @version $Revision: 158 $ 
 */
public class DistanceCalculatorFactoryTest{
    private DistanceCalculatorFactory factory;
    
    @Before
    public void setUp(){
        factory = DistanceCalculatorFactory.getInstance();
    }

    @Test
    public void testFactory(){
        Assert.assertTrue(factory.getDefaultItemDistanceCalculator() instanceof SquaredEuclideanItemDistanceCalculator);

        Assert.assertTrue(factory.getItemDistanceCalculator(ItemDistanceAlgorithm.MINKOWSKY_DISTANCE)  instanceof MinkowskyItemDistanceCalculator);
        Assert.assertTrue(factory.getItemDistanceCalculator(ItemDistanceAlgorithm.CITY_BLOCK_DISTANCE) instanceof CityBlockItemDistanceCalculator);
        Assert.assertTrue(factory.getItemDistanceCalculator(ItemDistanceAlgorithm.DOMINANCE_METRIC)    instanceof DominanceMetricCalculator);
    }
}
