package jp.sourceforge.talisman.mds.distance;

/*
 * $Id: DominanceMetricCalculatorTest.java 158 2008-07-15 10:45:01Z tama3 $
 */

import jp.sourceforge.talisman.mds.Item;
import jp.sourceforge.talisman.mds.distance.DistanceCalculatorFactory;
import jp.sourceforge.talisman.mds.distance.DominanceMetricCalculator;
import jp.sourceforge.talisman.mds.distance.ItemDistanceAlgorithm;
import jp.sourceforge.talisman.mds.distance.ItemDistanceCalculator;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

/**
 * 
 * @author Haruaki Tamada
 * @version $Revision: 158 $ 
 */
public class DominanceMetricCalculatorTest{
    private ItemDistanceCalculator distance;
    private Item item1;
    private Item item2;

    @Before
    public void initialize() throws Exception{
        DistanceCalculatorFactory factory = DistanceCalculatorFactory.getInstance();
        distance = factory.getItemDistanceCalculator(ItemDistanceAlgorithm.DOMINANCE_METRIC);

        item1 = new Item("item1", new double[] { 0, 0, 0, });
        item2 = new Item("item2", new double[] { 3, 4, 5, });
    }

    @Test
    public void testBasic2(){
        Assert.assertEquals(ItemDistanceAlgorithm.DOMINANCE_METRIC, distance.getAlgorithm());

        Assert.assertTrue(distance instanceof DominanceMetricCalculator);

        Assert.assertEquals(5d, distance.calculate(item1, item2), 1E-6);
        Assert.assertEquals(4d, distance.calculate(item1, item2, 2), 1E-6);
    }
}
