package jp.sourceforge.talisman.mds.distance;

/*
 * $Id: NormalizedEuclideanItemDistanceCalculatorTest.java 158 2008-07-15 10:45:01Z tama3 $
 */

import jp.sourceforge.talisman.mds.Item;
import jp.sourceforge.talisman.mds.distance.DistanceCalculatorFactory;
import jp.sourceforge.talisman.mds.distance.ItemDistanceAlgorithm;
import jp.sourceforge.talisman.mds.distance.ItemDistanceCalculator;
import jp.sourceforge.talisman.mds.distance.NormalizedEuclideanItemDistanceCalculator;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

/**
 * 
 * @author Haruaki Tamada
 * @version $Revision: 158 $ 
 */
public class NormalizedEuclideanItemDistanceCalculatorTest{
    private ItemDistanceCalculator distance;
    private Item item1;
    private Item item2;

    @Before
    public void initialize() throws Exception{
        DistanceCalculatorFactory factory = DistanceCalculatorFactory.getInstance();
        distance = factory.getItemDistanceCalculator(ItemDistanceAlgorithm.NORMALIZED_EUCLIDEAN_DISTANCE);

        item1 = new Item("item1", new double[] { 0, 0, 0, });
        item2 = new Item("item2", new double[] { 3, 4, 5, });
    }

    @Test
    public void testBasic(){
        Assert.assertEquals(ItemDistanceAlgorithm.NORMALIZED_EUCLIDEAN_DISTANCE, distance.getAlgorithm());

        Assert.assertTrue(distance instanceof NormalizedEuclideanItemDistanceCalculator);

        Assert.assertEquals(Math.sqrt(8.5d), distance.calculate(item1, item2), 1E-6);
        Assert.assertEquals(Math.sqrt(1.5625d), distance.calculate(item1, item2, 2), 1E-6);
    }
}
